#!/bin/bash
# Generates Apache rpm from  apache_1.3.*tar.gz source (in this directory)
# with built in Enhydra Director Module 
if 
	[ ! -f $(ls -1 apache_1.3.*tar.gz | tail -1) ] 
then
	echo "No apache source in this directory"
	exit 1
fi

if
	[ -d /usr/local/apache ]
then
	if
		/usr/local/apache/bin/apachectl stop | grep "not running"
	then
		startApache=N
	else
		startApache=Y
	fi
	mv /usr/local/apache /usr/local/apache.old
	if 
		[ -f /usr/local/apache/conf/httpd.conf ]
	then
		oldApacheRpm=$(rpm -qf /usr/local/apache/conf/httpd.conf)
	fi
	if 
		[ x$oldApacheRpm != x ]
	then
		rpm -e $oldApacheRpm
	fi
fi

if
	directorRpm=$(rpm -qa | grep apache-1.3[0-9.]*-director)
	[ x$directorRpm != x ]
then
	rpm -e $directorRpm
fi

chmod +x dos2unix_mod.sh
mkdir -p  apache-director-5.1/director
cd ../..
cp -r apache cgi common config libxml README.html README-TUNING.html test xml Install/Linux/apache-director-5.1/director
cd Install/Linux/apache-director-5.1/director
find apache config common -type f -exec ../../dos2unix_mod.sh {} \;

cd  ../..
mkdir -p ../../Distribution/Linux
RPM_DIR=/usr/src/redhat

for apacheSource in $(ls -1 apache_1.3.*tar.gz)
do
	echo -e "\n\n\n"
	echo "Building distribution for $apacheSource"
	echo -e "\n\n\n"
	sleep 5
	apacheVersion=$(echo $apacheSource | sed "s/apache_//
		s/.tar.gz//")
	apacheMinorVersion=$(echo $apacheVersion | sed "s/1.3.//")
	if
		[ $apacheMinorVersion -lt 9 ]
	then
		echo "Warning Enhydra Director module may or may not work with Apache version less then 1.3.9"
		sleep 5
	fi
	cp $apacheSource  $RPM_DIR/SOURCES/apache-${apacheVersion}.tar.gz
	sed  "/Version: /s/: .*/: $apacheVersion/" apache-so.spec > \
	$RPM_DIR/SPECS/apache-so-${apacheVersion}.spec
	rpmbuild -ba $RPM_DIR/SPECS/apache-so-${apacheVersion}.spec
	rpm -i  $RPM_DIR/RPMS/i386/apache-${apacheVersion}-1.so.i386.rpm
	tar -zvcf  $RPM_DIR/SOURCES/apache-${apacheVersion}-director-5.1.tar.gz  apache-director-5.1
	
	sed  "/Name: /s/: .*/: apache-${apacheVersion}-director/" apache-director-5.1.spec > \
		$RPM_DIR/SPECS/apache-${apacheVersion}-director-5.1.spec
	if
		rpmbuild -ba $RPM_DIR/SPECS/apache-${apacheVersion}-director-5.1.spec
	then
		cp $RPM_DIR/RPMS/i386/apache-${apacheVersion}-director-5.1-1.i386.rpm ../../Distribution/Linux
	else
		echo -e "\n\n\n"
		echo "Error: The rpm file could not been built"
		echo -e "\n\n\n"
	fi

	rpm -e apache-${apacheVersion}-1.so
done

rm -rf apache-director-5.1

if
        [ -d /usr/local/apache.old ]
then
	rm -rf /usr/local/apache
        mv /usr/local/apache.old /usr/local/apache
	if
		[ ${startApach:=Y} = Y ]
        then
                 /usr/local/apache/bin/apachectl start
        fi
fi

