;---------------------------------------------------------------------------------
; EnhydraDirector installation script
;	All output messages will be written to file ..\..\..\director_log.txt
;---------------------------------------------------------------------------------
#!define VERSION "5.1" ; need for building with makensisw.exe
;--------------------------------
;Version Information
  VIProductVersion "1.0.0.0"
  VIAddVersionKey ${LANG_ENGLISH} "FileVersion" "1.0.0"
  VIAddVersionKey ${LANG_ENGLISH} "LegalCopyright" " Together Teamlsungen GmbH"
  VIAddVersionKey ${LANG_ENGLISH} "FileDescription" "Enhydra Director"

  VIAddVersionKey ${LANG_ENGLISH} "ProductName" "Enhydra Director"
  VIAddVersionKey ${LANG_ENGLISH} "CompanyName" "Together Teamlsungen GmbH"
  VIAddVersionKey ${LANG_ENGLISH} "LegalTrademarks" "Enhydra Director Application is a trademark of Together Teamlsungen GmbH"
;--------------------------------

!define MUI_BRANDINGTEXT " EnhydraDirector for Windows  "

!define MUI_PRODUCT "EnhydraDirector" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here

!define MUI_ICON "${NSISDIR}\Contrib\Icons\enhydra1-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\enhydra1-uninstall.ico"

# defines SF_*, SECTION_OFF and some macros
!include Sections.nsh

!define MUI_UNTEXT_INTRO_TITLE "MUI_UNTEXT_INTRO_TITLE"
!define MUI_UNTEXT_INTRO_SUBTITLE "MUI_UNTEXT_INTRO_SUBTITLE"

XPStyle on

!include "MUI.nsh"
;---------------------------------------------------------------------------------
;Configuration
;---------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  
	!define MUI_CUSTOMFUNCTION_COMPONENTS_LEAVE	compLeave
  !define MUI_COMPONENTSPAGE 

	!define MUI_CUSTOMFUNCTION_DIRECTORY_PRE dirPre
  !define MUI_DIRECTORYPAGE 
  !define MUI_ABORTWARNING
	
  !define MUI_CUSTOMPAGECOMMANDS ; only for IIS, only for Apache or for IIS & Apache
  
  !define MUI_UNINSTALLER
	!define MUI_UNCUSTOMPAGECOMMANDS 
	
  !define TEMP1 $R0
  !define TEMP2 $R1
    
  ; Language
  !insertmacro MUI_LANGUAGE "English"

  ; General
  OutFile "..\..\..\Distribution\Windows\Director-${VERSION}.setup.exe"
  
  ;Window titles
  LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ": Choose Apache server to install Enhydra Director"

  ; Page order 
	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE
  !insertmacro MUI_PAGE_COMPONENTS 

  ; show only if Apache select
  Page custom SetApacheVersion "" ": Choose Apache server to install Enhydra Director" CheckSelection

  ; show only if IIS select
  !insertmacro MUI_PAGE_DIRECTORY
  Page custom SetCustomWarning "" ": WARNING"

  !insertmacro MUI_PAGE_INSTFILES
  
  ; License page (only on English language)
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\DirectorLicenseEnglish.txt"

  ; Folder-selection page for IIS
  InstallDir "C:\EnhydraDirector${VERSION}"

  ;Things that need to be extracted on startup (keep these lines before any File command!)
  ;Only useful for BZIP2 compression
  ;Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "apache.ini"  
  ReserveFile "director.ini"   
  ReserveFile "director1.ini"  
  ReserveFile "uninstall.ini"  
;---------------------------------------------------------------------------------
;Modern UI System
;---------------------------------------------------------------------------------
;Installer Sections for Apache
;---------------------------------------------------------------------------------
Section "EnhydraDirector for Apache" SecApache

  IfFileExists $TEMP\EnhydraDirectorApache\*.* 0 notExist ; check if temporary directory exists
  RMDir /r "$TEMP\EnhydraDirectorApache"                  ; if directory exists, then delete it
  
  notExist:
  StrCpy $R9 $INSTDIR                           ; keep $INSTALL directory 
  StrCpy $INSTDIR $TEMP\EnhydraDirectorApache   ; set $TEMP\EnhydraDirectorApache as an install directory
  SetOutPath "$INSTDIR"
  File /r "..\..\..\EnhydraDirectorApache\*.*"     ; extract files to $TEMP\EnhydraDirectorApache directory
  
  ; $8 = Apache Server root path for selected apache version
  ; $7 = Apache version string for selected apache version
 
  StrCpy $R8 $8 ; keep ALL server path string
  StrCpy $R7 $7 ; keep ALL version string
  StrCpy $R6 0  ; keep version 
  StrCpy $R5 0  ; handler for opened file 
  StrCpy $R0 0  ; temp variable
  StrCpy $R1 0  ; temp variable

  loop:
   ; extract version string, selected Apache server from cumulative version string
   ; path will be extracted to $R6
   Push $R7
   Push ","
   Call StrStr
   Pop $R0
    
   StrLen $R1 $R0         ; length of server root path string
   IntOp $R1 $R1 + 1      ; jump nick
   StrCpy $R7 $R7 "" $R1  ; $R7 = remainder of version string

   StrCpy $R6 $R0 ; $ R6 = version string

   ; extract path string, selected Apache server from cumulative path string
   ; path will be extracted to $R0
   Push $R8
   Push ","
   Call StrStr
   Pop $R0        ; $ R0 = server root path string
   
   StrLen $R1 $R0         ; length of server root path string
   IntOp $R1 $R1 + 1      ; jump nick
   StrCpy $R8 $R8 "" $R1  ; $R8 = remainder of server root path string
       
   ; Remove files from Apache Server path if exists 
   ; use variable $R0 
	 Call RemoveApache

   ; copy files to Apache server path from tmp directory
	 CopyFiles "$TEMP\EnhydraDirectorApache\mod_enhydra_director.so" "$R0\modules"
	 CopyFiles "$TEMP\EnhydraDirectorApache\enhydra_director.conf*" "$R0\conf"
	 CopyFiles "$R0\conf\httpd.conf" "$R0\conf\httpd.conf.save"

   ; modify file to load enhydra director modul 
   FileOpen  $R5 "$R0\conf\httpd.conf" a 
   FileSeek  $R5 0 END
   FileWrite $R5 "LoadModule enhydra_director_module modules/mod_enhydra_director.so$\r$\n"
   FileClose $R5

   ; check Apache service
   ClearErrors
   services::IsServiceInstalled 'Apache'
   Pop $0
   Pop $1
	 StrCmp $0 "Yes" checkRunning end
	 checkRunning:
   services::IsServiceRunning 'Apache'
   Pop $0
   Pop $1
	 StrCmp $0 "Yes" end startService
	 startService:
   services::SendServiceCommand 'start' 'Apache'
   Pop $0
   Pop $1
	 Sleep 1000
	 StrCmp $0 "Ok" end error
   end:
	 Sleep 5000
  
   ; replace "\\" with "\" from server root path string
   Push $R0
   Push "\\"
   Push "\"
   Call StrRep
   Pop $R0 

   ; write apache version and server root path to registry
   WriteRegStr HKLM "SOFTWARE\${MUI_PRODUCT}\Apache\$R6" "ServerRoot" "$R0"

   StrCmp $R8 "" continue 
   Goto loop

  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
  Abort

  continue:
	StrCpy $INSTDIR $R9
	SetOutPath $INSTDIR
  CreateDirectory "$INSTDIR\Apache"
  CopyFiles "$TEMP\EnhydraDirectorApache\INSTALL.TXT" "$INSTDIR\Apache"
  CopyFiles "$TEMP\EnhydraDirectorApache\*.ico" "$INSTDIR\Apache"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir" "$INSTDIR"
  WriteRegStr HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache" "$INSTDIR\Apache"
  
  ; Write the uninstall keys for Windows 
  WriteRegStr HKLM 	"Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" \
  									"DisplayName" "${MUI_PRODUCT} (remove only)"
  WriteRegStr HKLM 	"Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" \
  									"UninstallString" '"$R0\uninstall.exe"'
  WriteUninstaller "$INSTDIR\uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}"
  CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}\Apache"
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Apache\ApacheQuick start.lnk" \
                 "$INSTDIR\Apache\INSTALL.TXT" \
                 "" \
                 "$INSTDIR\Apache\apache.ico" 0
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Uninstall.lnk" \
                 "$INSTDIR\uninstall.exe" \
                 "" \
                 "$INSTDIR\uninstall.exe" 0
  ;Write language to the registry (for the uninstaller)
  WriteRegStr HKCU "Software\${MUI_PRODUCT}" "Installer Language" $LANGUAGE

  IfFileExists $TEMP\EnhydraDirectorApache\*.* 0 finish ; check if temporary directory exists
  RMDir /r "$TEMP\EnhydraDirectorApache"                  ; directory exists, delete it

  finish:
SectionEnd
;---------------------------------------------------------------------------------
;Installer Sections for IIS
;---------------------------------------------------------------------------------
Section "EnhydraDirector for IIS" SecIIS

  ; copy files to $TEMP directory
  IfFileExists $TEMP\EnhydraDirectorIIS\*.*	"" notExist
  RMDir /r "$TEMP\EnhydraDirectorIIS"
  
  notExist:
  StrCpy $R9 $INSTDIR                           ; keep $INSTALL directory 
  StrCpy $INSTDIR $TEMP\EnhydraDirectorIIS      ; set $TEMP\EnhydraDirectorApache like install directory
  SetOutPath "$INSTDIR"
  File /r "..\..\..\EnhydraDirectorIIS\*.*"     ; extract files to $TEMP\EnhydraDirectorApache directory
  
  ; $8 = Apache Server root path for selected Apache version
  ; $7 = Apache version string for selected Apache version
 
  StrCpy $R8 $8 ; keep ALL server path string
  StrCpy $R7 $7 ; keep ALL version string

	; Stop IIS, delete filter 'EnhydraFilter' and delete virtual directory 'EnhydraDirector'
	Call RemovelIIS
	
	; Copy files from $TEMP directory to install directory
	StrCpy $INSTDIR $R9
	SetOutPath $INSTDIR
	CreateDirectory $INSTDIR\IIS\uninstall
	CopyFiles /SILENT /FILESONLY "$TEMP\EnhydraDirectorIIS\*.*" "$INSTDIR\IIS"
	CopyFiles /SILENT /FILESONLY "$TEMP\EnhydraDirectorIIS\script\removeISAPIFilter.vbs" "$INSTDIR\IIS\uninstall\removeISAPIFilter.vbs"
	CopyFiles /SILENT /FILESONLY "$TEMP\EnhydraDirectorIIS\script\deleteVirtualDirectory.vbs" "$INSTDIR\IIS\uninstall\deleteVirtualDirectory.vbs"
  
  ; create EnhydraFilter and EnhydraDirector virtual directory
	Call InstallIIS
	
	; delete $TEMP\Enhydra directory
  RMDir /r "$TEMP\EnhydraDirectorIIS"
	
  WriteRegStr HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir" "$INSTDIR"
  WriteRegStr HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS" "$INSTDIR\IIS"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM 	"Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" \
  									"DisplayName" "${MUI_PRODUCT} (remove only)"
  WriteRegStr HKLM 	"Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" \
  									"UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "$INSTDIR\uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}"
  CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}\IIS"
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\IIS\IIS Quick start.lnk" \
                 "$INSTDIR\IIS\INSTALL.TXT" \
                 "" \
                 "$INSTDIR\IIS\iis.ico" 0
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Uninstall.lnk" \
                 "$INSTDIR\uninstall.exe" \
                 "" \
                 "$INSTDIR\uninstall.exe" 0

  ;Write language to the registry (for the uninstaller)
  WriteRegStr HKCU "Software\${MUI_PRODUCT}" "Installer Language" $LANGUAGE

  IfFileExists $TEMP\EnhydraDirectorIIS\*.*	"" finish
  RMDir /r "$TEMP\EnhydraDirectorIIS"
  finish:
SectionEnd
;---------------------------------------------------------------------------------
;Installer Functions
;---------------------------------------------------------------------------------
; Call on start installation
;---------------------------------------------------------------------------------
Function .onInit

  ; start splash screen
  ; the plugins dir is automatically deleted when the installer exits
	InitPluginsDir
	File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\welcomedirector.bmp"

  ; optional sound
  ;File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
	
	advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
	Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
  ;end splash screen

  ; Check OS system version, need : Microsoft Windows NT 4.0, Service Pack 6 or later.
  Call CheckOSVersion
  ; Check version of IIS, need : Microsoft Internet Information Server, version 4.0 or later.
  Call CheckVersionIIS
  ; Check version of Apache, need : 1.3.9-x version
  Call CheckVersionApache
  
  ; Check previously installation
  Call CheckEnhydraDirector  
  
  ; Check if is istalled IIS or Apache
	Call CheckComponents
	
  ;Extract Install Options INI Files, for custom page Apache install
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "apache.ini"
  
  ;Extract Install Options INI Files, for custom page IIS install
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "director.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "director1.ini"
	
  ;Extract Install Options INI Files, for custom page uninstall
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "uninstall.ini"
  
FunctionEnd
;---------------------------------------------------------------------------------
; Custom page for IIS installation
;---------------------------------------------------------------------------------
Function SetCustomWarning

	;check if IIS is selected
  SectionGetFlags ${SecIIS} $0
  IntOp $0 $0 & ${SF_SELECTED}
  StrCmp $0 ${SF_SELECTED} "" done

  !insertmacro MUI_HEADER_TEXT "Read Warning dialog" ""

  IfFileExists $INSTDIR\*.*	"" notExist

  StrCpy $R0 $INSTDIR
   Push $R0
   Push "\"
   Push "\\"
   Call StrRep
   Pop $R0 
  
  !insertmacro MUI_INSTALLOPTIONS_WRITE "director.ini" "Field 1" "Text" \
               "Installation directory : $R0 has already existed. Would you like to overwrite it ?"

  !insertmacro MUI_INSTALLOPTIONS_WRITE "director.ini" "Field 2" "Text" \
               "If answer is Yes, during installation filter named EnhydraFilter and virtual directory named EnhydraDirector on IIS, they will be overwrited or, if not, they will be created."
  StrCpy $R0 "director.ini"
  goto continue

  notExist:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "director1.ini" "Field 1" "Text" \
               "During installation filter named EnhydraFilter and virtual directory named EnhydraDirector on IIS, they will be overwrited or, if not, they will be created. Is that OK ?"

  StrCpy $R0 "director1.ini"

  continue:
# we don't want the DLL to unload so it will remember
#	our ini file when we are trying to show it
	InstallOptions::initDialog /NOUNLOAD $PLUGINSDIR\$R0
	Pop $0
	IntCmp $0 0 error
		; $0 is now the IO dialog HWND
		; use getdlgitem with it and sendmessage
		
		GetDlgItem $1 $0 1200 ; 1200 + field number - 1
		; $1 is now the HWND of the first field
		CreateFont $2 "Tahoma" 10 700 
		SendMessage $1 ${WM_SETFONT} $2 0
		
		GetDlgItem $1 $0 1201 ; 1200 + field number - 1
		; $1 is now the HWND of the first field
		CreateFont $2 "Tahoma" 10 700 
		SendMessage $1 ${WM_SETFONT} $2 0

		InstallOptions::show
		Pop $0
		StrCmp $0 "success" done
		StrCmp $0 "back" done
		StrCmp $0 "cancel" done
	error:
		MessageBox MB_OK|MB_ICONSTOP "IO error: $0"
		Quit

	done:  

FunctionEnd
;---------------------------------------------------------------------------------
; Custom page for Apache installation
;---------------------------------------------------------------------------------
Function SetApacheVersion

	;check if Apache component is selected, if isn't, go out from this page
  SectionGetFlags ${SecApache} $R0
  IntOp $R0 $R0 & ${SF_SELECTED}
  StrCmp $R0 ${SF_SELECTED} "" end

  !insertmacro MUI_HEADER_TEXT "Check box in the front of version where do you wish to install Enhydra Director" ""

  start:
  ; $9 - keep Apache version,ENABLED/DISABLED,Server root directory path
  StrCpy $R9 "" ; keep conntent of $9 variable
  StrCpy $R8 0 ; Number of field elements
  StrCpy $R0 0 ; temp variable
  StrCpy $R2 0 ; temp variable
  StrCpy $R1 0 ; temp variable
  StrCpy $R3 0 ; temp variable

  StrCpy $R9 $9

  ; loop for all Apache server with valid version
  loop:
   
   ; extract element for Apache server from string
   Push $R9
   Push ","
   Call StrStr
   Pop $R0
  
   StrCpy $R2 $R0
   IntOp $R8 $R8 + 1      ; field_elements = field_elements + 1
   StrLen $R1 $R2         ; length of extracted string
   IntOp $R1 $R1 + 1      ; jump nick 
   StrCpy $R9 $R9 "" $R1  ; copy remainder string 

   ; extract Apache version from string
   Push $R2
   Push "|"
   Call StrStr
   Pop $R0                ; $R0 = value of Apache string version 

   StrLen $R1 $R0         ; length of string version
   IntOp $R1 $R1 + 1      ; jump "|"
   StrCpy $R2 $R2 "" $R1  ; copy remainder string 

   ; put value of Apache string version to .ini file for custom page
   !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Field $R8" \
               "Text" \
               "$R0"

   ; extract ENABLED/DISABLED from string
   Push $R2
   Push "|"
   Call StrStr
   Pop $R0

   ; put value ENABLED/DISABLED to .ini file for custom page
  !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Field $R8" \
               "Flags" \
               "$R0"

   StrLen $R1 $R0         ; length of ENABLED/DISABLED string
   IntOp $R1 $R1 + 1
   StrCpy $R2 $R2 "" $R1

   IntOp $R8 $R8 + 1      ; field_elements = field_elements + 1 

   ; extract server root path from string
   Push $R2
   Push "|"
   Call StrStr
   Pop $R0

   ; replace "\\" with "\" from server root path string
   Push $R0
   Push "\"
   Push "\\"
   Call StrRep
   Pop $R0 

   ; put value server root path to .ini file for custom page
   !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Field $R8" \
               "Text" \
               "$R0"
 
   StrCmp $R9 "" "" loop ; check if end of elements

   ; put value of field elements to .ini file for custom page
  !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Settings" \
               "NumFields" \
               "$R8"
      
  StrCpy $R0 "apache.ini"
  InstallOptions::initDialog /NOUNLOAD $PLUGINSDIR\$R0
	Pop $0
	IntCmp $0 0 error
		; $0 is now the IO dialog HWND
		; use getdlgitem with it and sendmessage
		
		GetDlgItem $1 $0 1200 ; 1200 + field number - 1
		; $1 is now the HWND of the first field
		
		GetDlgItem $1 $0 1201 ; 1200 + field number - 1
		; $1 is now the HWND of the first field

		InstallOptions::show
		Pop $0
		StrCmp $0 "success" done
		StrCmp $0 "back" end
		StrCmp $0 "cancel" end
	error:
		MessageBox MB_OK|MB_ICONSTOP "IO error: $0"
		Quit

	done:  
    Call CheckSelection ; check if anything is selected
    StrCmp $8 "" start  ; if nothing is selected goto start of page

  end:
FunctionEnd
;---------------------------------------------------------------------------------
; POST function for Apache custom page
; check if anything is selected
;---------------------------------------------------------------------------------
 Function CheckSelection

  StrCpy $8 ""  ; Apache Server root path for selected apache version
  StrCpy $7 ""  ; Apache version string for selected apache version
  StrCpy $R8 0  ; count number of field elements
  StrCpy $R9 0  ; number of field elements
  StrCpy $R1 "" ; keep state
  StrCpy $R2 "" ; keep string version 
  StrCpy $R3 "" ; keep string server root path
  
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R9 \
               "apache.ini" \
               "Settings" \
               "NumFields" 

  ; read content of .ini file and check state of check boxes
  loop:
    ; field_elements = field_elements + 1
    IntOp $R8 $R8 + 1

    ; check if check box is selected
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R1 \
               "apache.ini" \
               "Field $R8" \
               "state" 
               
    ; read version string after check box
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R2 \
               "apache.ini" \
               "Field $R8" \
               "text" 
               
    IntOp $R8 $R8 + 1 ; field_elements = field_elements + 1

    StrCmp $R1 "0" continue ; check if check box is selected

    ; read string server root path
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R3 \
               "apache.ini" \
               "Field $R8" \
               "text" 

    ; replace "\\" with "\" on path string
    Push $R3
    Push "\\"
    Push "\"
    Call StrRep
    Pop $R0 

    ; make selected Apache version string
    StrCmp $7 "" c11
    StrCpy $7 "$7,"
    c11:
    StrCpy $7 $7$R2

    ; make selected Apache server root path string
    StrCmp $8 "" c1
    StrCpy $8 "$8,"
    c1:
    StrCpy $8 $8$R3

    continue:
    StrCmp $R8 $R9 checkSelect ; check if all elements are checked
    Goto loop

  checkSelect:
    StrCmp $8 "" "" ok ; check if anything is selected
    MessageBox MB_OK|MB_ICONINFORMATION 'You must check Apache version where do you want to install Enhydra Director.'
      
   ok:
FunctionEnd
;---------------------------------------------------------------------------------
; POST function for Apache custom page
; check if anything is selected
;---------------------------------------------------------------------------------
 Function un.CheckSelection

  StrCpy $8 ""  ; Apache Server root path for selected apache version
  StrCpy $7 ""  ; Apache version string for selected apache version
  StrCpy $R8 0  ; count number of field elements
  StrCpy $R9 0  ; number of field elements
  StrCpy $R1 "" ; keep state
  StrCpy $R2 "" ; keep string version 
  StrCpy $R3 "" ; keep string server root path
  
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R9 \
               "apache.ini" \
               "Settings" \
               "NumFields" 

  ; read content of .ini file and check the state of check boxes
  loop:
    ; field_elements = field_elements + 1
    IntOp $R8 $R8 + 1

    ; check if check box is selected
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R1 \
               "apache.ini" \
               "Field $R8" \
               "state" 
               
    ; read version string after check box
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R2 \
               "apache.ini" \
               "Field $R8" \
               "text" 
               
    IntOp $R8 $R8 + 1 ; field_elements = field_elements + 1

    StrCmp $R1 "0" continue ; check if check box is selected

    ; read string server root path
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $R3 \
               "apache.ini" \
               "Field $R8" \
               "text" 

    ; replace "\\" with "\" on path string
    Push $R3
    Push "\\"
    Push "\"
    Call un.StrRep
    Pop $R0 

    ; make selected Apache version string
    StrCmp $7 "" c11
    StrCpy $7 "$7,"
    c11:
    StrCpy $7 $7$R2

    ; make selected Apache server root path string
    StrCmp $8 "" c1
    StrCpy $8 "$8,"
    c1:
    StrCpy $8 $8$R3

    continue:
    StrCmp $R8 $R9 checkSelect ; check if all elements are checked
    Goto loop

  checkSelect:
    StrCmp $8 "" "" ok ; check if anything is selected
    MessageBox MB_OK|MB_ICONINFORMATION 'You must check Apache version where do you want to install Enhydra Director.'
      
   ok:
FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation success
;---------------------------------------------------------------------------------
Function .onInstSuccess

	;check if IIS selected
  SectionGetFlags ${SecIIS} $0
  IntOp $0 $0 & ${SF_SELECTED}
  StrCmp $0 ${SF_SELECTED} ok end

  ok:
  services::SendServiceCommand 'start' 'W3SVC'
  Pop $0
	StrCmp $0 "Ok"  end

	MessageBox MB_OK|MB_ICONSTOP "Error starting World Wide Web Publishing Service. Start service manually."

	end:
FunctionEnd
;---------------------------------------------------------------------------------
; Descriptions
;---------------------------------------------------------------------------------
LangString DESC_SecApache ${LANG_ENGLISH} "Install Enhydra Director for Apache HTTP Server."
LangString DESC_SecIIS ${LANG_ENGLISH} "Install Enhydra Director for Microsoft Internet Information Server."

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecApache} $(DESC_SecApache)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecIIS} $(DESC_SecIIS)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END
;---------------------------------------------------------------------------------
; Unisntall defined pages
;---------------------------------------------------------------------------------
ShowUninstDetails show

UninstPage custom un.UninstallPage ; "Uninstall Enhydra Director" ;Custom page
UninstPage custom un.UninstallApachePage ; "Uninstall Enhydra Director for Apache" ; Custom page for Apache 
!insertmacro MUI_UNPAGE_INSTFILES
;---------------------------------------------------------------------------------
;Uninstaller Section
;---------------------------------------------------------------------------------
Section "Uninstall"

  ; $6 = keep if Apache is selected for uninstalation
  ; $5 = keep if IIS is selected for uninstalation

	StrCmp $5 "1" "" continue
	Call un.UninstallIIS

  continue:
	StrCmp $6 "1" "" end
	Call un.UninstallApache	

  end:
SectionEnd
;---------------------------------------------------------------------------------
;Uninstaller Section
;---------------------------------------------------------------------------------
Function un.UninstallPage

  !insertmacro MUI_HEADER_TEXT "Check box in front of component which do you want to uninstall" ""

  start:
  StrCpy $R0 "uninstall.ini"

#  we don't want the DLL to unload so it will remember
#	 our ini file when we are trying to show it
	InstallOptions::initDialog /NOUNLOAD $PLUGINSDIR\$R0
	Pop $0
	IntCmp $0 0 error
		; $0 is now the IO dialog HWND
		; use getdlgitem with it and sendmessage
		
		GetDlgItem $1 $0 1200 ; 1200 + field number - 1
		; $1 is now the HWND of the first field
		CreateFont $2 "Tahoma" 10 700 
		SendMessage $1 ${WM_SETFONT} $2 0
		
		InstallOptions::show
		Pop $0
		StrCmp $0 "success" done
		StrCmp $0 "back" done
		StrCmp $0 "cancel" cancel
	error:
		MessageBox MB_OK|MB_ICONSTOP "IO error: $0"
		Quit

	done:  
	Call un.CheckUninstallSelection ; check if anything is selected for uninstall
	StrCmp $6 "0" "" end
	StrCmp $5 "0" "" end
	Goto start
	
	cancel:
	Quit
	
	end:
FunctionEnd
;---------------------------------------------------------------------------------
; Custom page for apache uninstall
;---------------------------------------------------------------------------------
Function un.UninstallApachePage

  !insertmacro MUI_HEADER_TEXT "Check box in front of component which do you want to uninstall" ""

  ; $6 = keep if Apache check for uninstalation
  ; $5 = keep if IIS check for uninstalation
  ; $7 - keep Apache version,Server root directory path
  
  StrCmp $6 "0" end

  start0:
  ; make custom page
  StrCpy $R8 0   ; count elemnts from .ini file
  StrCpy $7 ""   ; keep Apache version|path,version1|path1,... 
  StrCpy $R0 0   ; count EnumRegKey from "Software\Apache Group\Apache" 
  StrCpy $R1 ""  ; keep apache version
  StrCpy $R2 ""  ; keep server root path
  
  ; read from the registry which apache version is installed
  loop0:
    EnumRegKey $R1 HKLM "SOFTWARE\${MUI_PRODUCT}\Apache" $R0
    StrCmp $R1 "" start
    ReadRegStr $R2 HKLM "SOFTWARE\${MUI_PRODUCT}\Apache\$R1" "ServerRoot"      
    StrCpy $7 "$7$R1|$R2,"
    IntOp $R0 $R0 + 1
  goto loop0
  
  start:  

  StrCpy $R9 "" 
  StrCpy $R0 "0" 
  
  StrCpy $R9 $7 ; keep content of $7 variable
  ; loop for all installed Apache server
  loop:
   
   ; extract element for Apache server from string
   Push $R9
   Push ","
   Call un.StrStr
   Pop $R0

   StrCpy $R2 $R0
   IntOp $R8 $R8 + 1      ; field_elements = field_elements + 1
   StrLen $R1 $R2         ; length of extracted string
   IntOp $R1 $R1 + 1      ; jump nick 
   StrCpy $R9 $R9 "" $R1  ; copy remainder string 

   ; extract Apache version from string
   Push $R2
   Push "|"
   Call un.StrStr
   Pop $R0                ; $R0 = value of Apache string version 

   StrLen $R1 $R0         ; length of string version
   IntOp $R1 $R1 + 1      ; jump "|"
   StrCpy $R2 $R2 "" $R1  ; copy remainder string 

   ; put value of Apache string version to .ini file for custom page
   !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Field $R8" \
               "Flags" \
               "ENABLED"
               
   !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Field $R8" \
               "Text" \
               "$R0"

   IntOp $R8 $R8 + 1      ; field_elements = field_elements + 1 

   ; extract server root path from string
   Push $R2
   Push "|"
   Call un.StrStr
   Pop $R0

   ; replace "\\" with "\" from server root path string
   Push $R0
   Push "\"
   Push "\\"
   Call un.StrRep
   Pop $R0 

   ; put value server root path to .ini file for custom page
   !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Field $R8" \
               "Text" \
               "$R0"
 
   StrCmp $R9 "" "" loop ; check if end of elements

   ; put value of field elements to .ini file for custom page
  !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "apache.ini" \
               "Settings" \
               "NumFields" \
               "$R8"
      
  StrCpy $R0 "apache.ini"
  
  InstallOptions::initDialog /NOUNLOAD $PLUGINSDIR\$R0
	Pop $0
	IntCmp $0 0 error
		; $0 is now the IO dialog HWND
		; use getdlgitem with it and sendmessage
		
		InstallOptions::show
		Pop $0
		StrCmp $0 "success" done
		StrCmp $0 "back" end
		StrCmp $0 "cancel" end
	error:
		MessageBox MB_OK|MB_ICONSTOP "IO error: $0"
		Quit

	done:  
    Call un.CheckSelection ; check if anything is selected
    StrCmp $8 "" start0    ; if nothing is selected goto the start of page

  end:
FunctionEnd
;---------------------------------------------------------------------------------
;Uninstaller function for Apache
;---------------------------------------------------------------------------------
Function un.UninstallApache 

  StrCpy $R8 $8 ; input - keep ALL server path string
  StrCpy $R7 $7 ; input - keep ALL version string

  StrCpy $R6 0  ; keep version 
  StrCpy $R5 0  ; handler for opened file 
  StrCpy $R0 0  ; temp variable
  StrCpy $R1 0  ; temp variable

  ; loop for uninstall 
  loop:
   ; extract version string, selected Apache server from cumulative version string
   ; path will be extracted to $R6
   Push $R7
   Push ","
   Call un.StrStr
   Pop $R0
   StrCpy $R6 $R0 ; $ R6 = version string

   ; extract path for selected Apache server from cumulative path string
   ; path will be extracted to $R0
   Push $R8
   Push ","
   Call un.StrStr
   Pop $R0        ; $ R0 = server root path string

   StrLen $R1 $R0         ; length of server root path string
   IntOp $R1 $R1 + 1      ; jump nick
   StrCpy $R8 $R8 "" $R1  ; $R8 = remainder of server root path string

   ; replace "\\" with "\" from server root path string
   Push $R0
   Push "\\"
   Push "\"
   Call un.StrRep
   Pop $R0 
   
   ; Remove files from Apache Server path if exists 
   ; used variable $R0 
	 Call un.RemoveApache

   ; check Apache service
   ClearErrors
   services::IsServiceInstalled 'Apache'
   Pop $0
   Pop $1
	 StrCmp $0 "Yes" checkRunning end
	 checkRunning:
   services::IsServiceRunning 'Apache'
   Pop $0
   Pop $1
	 StrCmp $0 "Yes" end startService0
	 startService0:
   services::SendServiceCommand 'start' 'Apache'
   Pop $0
   Pop $1
	 Sleep 1000
	 StrCmp $0 "Ok" end error
   end:
	 Sleep 5000
  
   ; delete apache version server root path from the registry
   DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}\Apache\$R6"

   StrCmp $R8 "" continue 
   Goto loop

  continue:
  ; remove registry keys
  ; read from the registry if IIS is installed
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS"
  StrCmp $R0 "" "" iisinstaled

#  StrCpy $R0 0   ; count EnumRegKey from "Software\Apache Group\Apache" 
#  EnumRegKey $R1 HKLM "SOFTWARE\${MUI_PRODUCT}\Apache" $R0
#  StrCmp $R1 "" removeApache
#	Goto startservice
#	
#	removeApache:
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}"
  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\*.*"
  ; remove directories used.
  RMDir /r "$SMPROGRAMS\${MUI_PRODUCT}"
  Delete "$INSTDIR\IIS\*.*"
  Delete "$INSTDIR\Apache\*.*"
  RMDir /r "$INSTDIR\IIS"
  RMDir "$INSTDIR\Apache"
  RMDir  "$INSTDIR"
  goto startservice
  
  iisinstaled:
  DeleteRegValue HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache"
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\Apache\*.*"
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}\Apache"
  ; remove directories used.
  Delete "$INSTDIR\Apache\*.*"
  RMDir "$INSTDIR\Apache"

  startservice:
  Goto end1
	
	error:
	MessageBox MB_OK|MB_ICONSTOP "Error starting World Wide Web Publishing Service. Start service manually."

	end1:
FunctionEnd
;---------------------------------------------------------------------------------
;Uninstaller function for IIS
;---------------------------------------------------------------------------------
Function un.UninstallIIS 

  ; $5 = keep if IIS is selected for uninstallation

 	; stop IIS, delete EnhydraDirector virtual directory, delete EnhydraFileter and start IIS again
	Call un.RemovelIIS

  ; remove registry keys
  ; read from the registry if Apache installed
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache"
  StrCmp $R0 "" "" apacheinstaled

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}"
  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\*.*"
  ; remove directories used.
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}"
  Delete "$INSTDIR\IIS\*.*"
  Delete "$INSTDIR\Apache\*.*"
  RMDir /r "$INSTDIR\IIS"
  RMDir "$INSTDIR\Apache"
  RMDir "$INSTDIR"
  goto startservice
  
  apacheinstaled:
  DeleteRegValue HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS"
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\IIS\*.*"
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}\IIS"
  ; remove directories used.
  Delete "$INSTDIR\IIS\*.*"
  RMDir /r "$INSTDIR\IIS"

  startservice:
  services::SendServiceCommand 'start' 'W3SVC'
  Pop $0
	StrCmp $0 "Ok" "" error
  Goto end
	
	error:
	MessageBox MB_OK|MB_ICONSTOP "Error starting World Wide Web Publishing Service. Start service manually."

	end:
FunctionEnd
;---------------------------------------------------------------------------------
;Install Uninstaller function for Apache
;---------------------------------------------------------------------------------
Function UninstallApache 

#  MessageBox MB_OK "Usao UninstallApache"

  StrCpy $R8 $8 ; input - keep ALL server path string
  StrCpy $R7 $7 ; input - keep ALL version string

  StrCpy $R6 0  ; keep version 
  StrCpy $R5 0  ; handler for opened file 
  StrCpy $R0 0  ; temp variable
  StrCpy $R1 0  ; temp variable

  ; loop for uninstall 
  loop:
   ; extract version string, selected Apache server from cumulative version string
   ; path will be extracted to $R6
   Push $R7
   Push ","
   Call StrStr
   Pop $R0
   StrCpy $R6 $R0 ; $ R6 = version string

   ; extract path for selected Apache server from cumulative path string
   ; path will be extracted to $R0
   Push $R8
   Push ","
   Call StrStr
   Pop $R0        ; $ R0 = server root path string

   StrLen $R1 $R0         ; length of server root path string
   IntOp $R1 $R1 + 1      ; jump nick
   StrCpy $R8 $R8 "" $R1  ; $R8 = remainder of server root path string

   ; replace "\\" with "\" from server root path string
   Push $R0
   Push "\\"
   Push "\"
   Call StrRep
   Pop $R0 
   
   ; Remove files from Apache Server path if exists 
   ; used variable $R0 
	 Call UnRemoveApache

   ; check Apache service
   ClearErrors
   services::IsServiceInstalled 'Apache'
   Pop $0
   Pop $1
	 StrCmp $0 "Yes" checkRunning end
	 checkRunning:
   services::IsServiceRunning 'Apache'
   Pop $0
   Pop $1
	 StrCmp $0 "Yes" end startService0
	 startService0:
   services::SendServiceCommand 'start' 'Apache'
   Pop $0
   Pop $1
	 Sleep 1000
	 StrCmp $0 "Ok" end error
   end:
	 Sleep 5000
  
   ; delete apache version server root path from the registry
   DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}\Apache\$R6"

   StrCmp $R8 "" continue 
   Goto loop

  continue:
  ; remove registry keys
  ; read from the registry if IIS is installed
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS"
  StrCmp $R0 "" "" iisinstaled

#  StrCpy $R0 0   ; count EnumRegKey from "Software\Apache Group\Apache" 
#  EnumRegKey $R1 HKLM "SOFTWARE\${MUI_PRODUCT}\Apache" $R0
#  StrCmp $R1 "" removeApache
#	Goto startservice
#	
#	removeApache:
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}"
  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\*.*"
  ; remove directories used.
  RMDir /r "$SMPROGRAMS\${MUI_PRODUCT}"
  Delete "$INSTDIR\IIS\*.*"
  Delete "$INSTDIR\Apache\*.*"
  RMDir /r "$INSTDIR\IIS"
  RMDir "$INSTDIR\Apache"
  RMDir  "$INSTDIR"
  goto startservice
  
  iisinstaled:
  DeleteRegValue HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache"
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\Apache\*.*"
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}\Apache"
  ; remove directories used.
  Delete "$INSTDIR\Apache\*.*"
  RMDir "$INSTDIR\Apache"

  startservice:
  Goto end1
	
	error:
	MessageBox MB_OK|MB_ICONSTOP "Error starting World Wide Web Publishing Service. Start service manually."

	end1:
FunctionEnd
;---------------------------------------------------------------------------------
;Install Uninstaller function for IIS
;---------------------------------------------------------------------------------
Function UninstallIIS 

  ; $5 = keep if IIS is selected for uninstallation

#  MessageBox MB_OK "Usao UninstallIIS"

 	; stop IIS, delete EnhydraDirector virtual directory, delete EnhydraFileter and start IIS again
	Call UnRemovelIIS

#  MessageBox MB_OK "Usao UninstallIIS-prosao UnRemovelIIS"
  ; remove registry keys
  ; read from the registry if Apache installed
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache"
  StrCmp $R0 "" "" apacheinstaled

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}"
  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\*.*"
  ; remove directories used.
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}"
  Delete "$INSTDIR\IIS\*.*"
  Delete "$INSTDIR\Apache\*.*"
  RMDir /r "$INSTDIR\IIS"
  RMDir "$INSTDIR\Apache"
  RMDir "$INSTDIR"
  goto startservice
  
  apacheinstaled:
  DeleteRegValue HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS"
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\IIS\*.*"
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}\IIS"
  ; remove directories used.
  Delete "$INSTDIR\IIS\*.*"
  RMDir /r "$INSTDIR\IIS"

  startservice:
  services::SendServiceCommand 'start' 'W3SVC'
  Pop $0
	StrCmp $0 "Ok" "" error
  Goto end
	
	error:
	MessageBox MB_OK|MB_ICONSTOP "Error starting World Wide Web Publishing Service. Start service manually."

	end:
FunctionEnd





;---------------------------------------------------------------------------------
; Uninstaller Functions
;---------------------------------------------------------------------------------
; Call on uninstall init
;---------------------------------------------------------------------------------
Function un.onInit

  StrCpy $R0 0 ; keep if IIS installed
  StrCpy $R1 0 ; keep if Apache installed
  
  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "uninstall.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "apache.ini"

  ; read from the registry which commponents are installed 
  ReadRegStr $R1 HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache"
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS"

  ; Apache check box
  StrCmp $R1 "" "" continue
  !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "uninstall.ini" \
               "Field 2" \
               "Flags" \
               "DISABLED"
               
  ; IIS check box
  continue:
  StrCmp $R0 "" "" end
  !insertmacro MUI_INSTALLOPTIONS_WRITE \
               "uninstall.ini" \
               "Field 3" \
               "Flags" \
               "DISABLED"

  end:  
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
FunctionEnd
;---------------------------------------------------------------------------------------
; Remove files instaled for Apache, call on uninstall
;---------------------------------------------------------------------------------------
Function un.RemoveApache

  Banner::show /NOUNLOAD /set 76 "Shutdown Apache Server," "please wait ..."

	nsExec::ExecToLog '"$R0\apache.exe" -k shutdown > "$R0\logs\shutdown.log"'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" "" error

	Sleep 7000
  IfFileExists $R0\conf\httpd.conf.save	0 end
	Delete "$R0\modules\mod_enhydra_director.so"
	Delete "$R0\conf\enhydra_director.conf*"
	CopyFiles "$R0\conf\httpd.conf.save" "$R0\conf\httpd.conf"
	Delete "$R0\conf\httpd.conf.save"
	Delete "$R0\conf\enhydra_director.conf.save"
  Goto end
  
 error:
 MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
 Abort

 end:
 Banner::destroy
FunctionEnd
;---------------------------------------------------------------------------------------
; Remove files instaled for Apache, call on uninstall
;---------------------------------------------------------------------------------------
Function UnRemoveApache

  Banner::show /NOUNLOAD /set 76 "Shutdown Apache Server," "please wait ..."

	nsExec::ExecToLog '"$R0\apache.exe" -k shutdown > "$R0\logs\shutdown.log"'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" "" error

	Sleep 7000
  IfFileExists $R0\conf\httpd.conf.save	0 end
	Delete "$R0\modules\mod_enhydra_director.so"
	Delete "$R0\conf\enhydra_director.conf*"
	CopyFiles "$R0\conf\httpd.conf.save" "$R0\conf\httpd.conf"
	Delete "$R0\conf\httpd.conf.save"
	Delete "$R0\conf\enhydra_director.conf.save"
  Goto end
  
 error:
 MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
 Abort

 end:
 Banner::destroy
FunctionEnd
;--------------------------------------------------------------------------
; Remove files instaled for Apache Server
;--------------------------------------------------------------------------
Function RemoveApache

  Banner::show /NOUNLOAD /set 76 "Shutdown Apache Server," "please wait ..."

	; if Apache server is started like service or console, stop it
	nsExec::ExecToLog '"$R0\apache.exe" -k shutdown > "$R0\logs\shutdown.log"'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	
	StrCmp $0 "0" "" error
	Sleep 7000
  IfFileExists $R0\conf\httpd.conf.save	0 end
	Delete "$R0\modules\mod_enhydra_director.so"
	Delete "$R0\conf\enhydra_director.conf*"
	CopyFiles "$R0\conf\httpd.conf.save" "$R0\conf\httpd.conf"
	Delete "$R0\conf\httpd.conf.save"
	Delete "$R0\conf\enhydra_director.conf.save"
  Goto end
  
  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
  Abort

  end:
 Banner::destroy
FunctionEnd
;-----------------------------------------------------------------------------
; Check version of Apache, verion needed : 1.3.9-x
;-----------------------------------------------------------------------------
Function CheckVersionApache

  StrCpy $R0 0   ; count EnumRegKey from "Software\Apache Group\Apache" 
  StrCpy $R2 ""  ; check Apache server version ENABLED/DISABLED
  StrCpy $R3 "0" ; 0 - Apache 1.3.9-x NOT instaled, 
                 ; 1 - Apache 1.3.9-x instaled
  StrCpy $R4 ""  ; keep Apache server path
  StrCpy $R1 ""  ; temp variable
  StrCpy $R5 ""  ; temp variable
  StrCpy $R6 ""  ; temp variable
                 
  StrCpy $8 0    ; indicator if Apache server version 1.3.9-x is existing (0-not exist, 1-exist)
  StrCpy $9 ""   ; keep Apache version,ENABLED/DISABLED,Server root directory path
	
	; check lokal install
  loop:
    StrCpy $R2 "DISABLED"
    EnumRegKey $R1 HKCU "Software\Apache Group\Apache" $R0
    StrCmp $R1 "" abort
    ReadRegStr $R4 HKCU "Software\Apache Group\Apache\$R1" "ServerRoot"      

		; remove char "\" from the end if exist
		StrCpy $R5 $R4 "" -1
		StrCmp $R5 "\" "" continue00
		StrLen $R6 $R4
		IntOp $R6 $R6 - 1
		StrCpy $R4 $R4 $R6
    
    continue00:
    ; Apache version must be >= 1.3.9-x
    StrCpy $5 $R1 3 
    StrCpy $2 $R1 "" 4
    StrCmp $5 "1.3" "" continue
    IntCmp $2 9 ok "" ok

    continue:
    
    ; keep all path
    StrCpy $9 "$9$R1|$R2|$R4|,"
    
    IntOp $R0 $R0 + 1
  Goto loop
    
    ok:
    ; keep enabled all path
    StrCpy $R2 "ENABLED"

    StrCpy $R3 1
    ; keep Apache Server root directory path
  Goto continue
  
  abort:
  StrCpy $R0 0
	; check network install
  loopNet:
    StrCpy $R2 "DISABLED"
    EnumRegKey $R1 HKLM "Software\Apache Group\Apache" $R0
    StrCmp $R1 "" abortNet
    ReadRegStr $R4 HKLM "Software\Apache Group\Apache\$R1" "ServerRoot"      
    
		; remove char "\" from the end if exist
		StrCpy $R5 $R4 "" -1
		StrCmp $R5 "\" "" continue000
		StrLen $R6 $R4
		IntOp $R6 $R6 - 1
		StrCpy $R4 $R4 $R6

    continue000:
    ; Apache version must be >= 1.3.9-x
    StrCpy $5 $R1 3 
    StrCpy $2 $R1 "" 4
    StrCmp $5 "1.3" "" continueNet
    IntCmp $2 9 okNet "" okNet

    continueNet:
    ; keep all path
    StrCpy $9 "$9$R1|$R2|$R4|,"

    IntOp $R0 $R0 + 1
  Goto loopNet
    
    okNet:
    ; keep enabled all path
    StrCpy $R2 "ENABLED"

    StrCpy $R3 1
  Goto continueNet
    
  abortNet:
  IntCmp $R3 1 end wrongVersion
    
  wrongVersion:
	SectionSetFlags ${SecApache} ${SF_RO}
	
	end:
	StrCpy $8 1 ; are the requirements for Apache version OK

FunctionEnd
;---------------------------------------------------------------------------
; Check if istalled IIS or Apache
;---------------------------------------------------------------------------
Function CheckComponents

	StrCmp $8 "0" "" end ; check if required components are ready for starting of the installation
  MessageBox MB_OK|MB_ICONINFORMATION 'Required for starting of the installation: Apache version 1.3.9-x or Microsoft Internet Information Server, version 4.0 or later'
	Quit

	end:
FunctionEnd
;-----------------------------------------------------------------------
; Check OS system version is needed to install EnhydraDirector 
; OS system needed : Microsoft Windows NT 4.0, Service Pack 6 or later.
;-----------------------------------------------------------------------
Function CheckOSVersion

  Call GetWindowsVersion
  Pop $0
  StrCmp $0 "95" error
  StrCmp $0 "98" error
  StrCmp $0 "ME" error
  StrCmp $0 "NT 4.0" checkVerion
  goto ok
  
  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'You must have installed Microsoft Windows NT 4.0, Service Pack 6 or later'
	Abort
    
  checkVerion:
	sysinfo::GetSystemVersionValue 'ServicePackMajorVersion'  
	Pop $0
  StrCmp $0 "6" "" error
	
	ok:
FunctionEnd
;-----------------------------------------------------------------------
; GetWindowsVersion
;
; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
; Updated by Joost Verburg
;
; Returns on top of stack
;
; Windows Version (95, 98, ME, NT x.x, 2000, XP, 2003)
; or
; '' (Unknown Windows Version)
;
; Usage:
;   Call GetWindowsVersion
;   Pop $R0
;   ; at this point $R0 is "NT 4.0" or whatnot
;-----------------------------------------------------------------------
Function GetWindowsVersion

  Push $R0
  Push $R1

  ReadRegStr $R0 HKLM \
  "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion

  IfErrors 0 lbl_winnt
  
  ; we are not NT
  ReadRegStr $R0 HKLM \
  "SOFTWARE\Microsoft\Windows\CurrentVersion" VersionNumber

  StrCpy $R1 $R0 1
  StrCmp $R1 '4' 0 lbl_error

  StrCpy $R1 $R0 3

  StrCmp $R1 '4.0' lbl_win32_95
  StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98

  lbl_win32_95:
    StrCpy $R0 '95'
  Goto lbl_done

  lbl_win32_98:
    StrCpy $R0 '98'
  Goto lbl_done

  lbl_win32_ME:
    StrCpy $R0 'ME'
  Goto lbl_done

  lbl_winnt:

  StrCpy $R1 $R0 1

  StrCmp $R1 '3' lbl_winnt_x
  StrCmp $R1 '4' lbl_winnt_x

  StrCpy $R1 $R0 3

  StrCmp $R1 '5.0' lbl_winnt_2000
  StrCmp $R1 '5.1' lbl_winnt_XP
  StrCmp $R1 '5.2' lbl_winnt_2003 lbl_error

  lbl_winnt_x:
    StrCpy $R0 "NT $R0" 6
  Goto lbl_done

  lbl_winnt_2000:
    Strcpy $R0 '2000'
  Goto lbl_done

  lbl_winnt_XP:
    Strcpy $R0 'XP'
  Goto lbl_done

  lbl_winnt_2003:
    Strcpy $R0 '2003'
  Goto lbl_done

  lbl_error:
    Strcpy $R0 ''
  lbl_done:

  Pop $R1
  Exch $R0

FunctionEnd
;-----------------------------------------------------------------------
; StrStr
; input, top of stack = string to search for
;        top of stack-1 = string to search in
; output, top of stack (replaces with the portion of the string remaining)
; modifies no other variables.
;
; Usage:
;   Push "this is a long ass string"
;   Push "ass"
;   Call StrStr
;   Pop $R0
;  ($R0 at this point is "this is a long ")
;-----------------------------------------------------------------------
Function StrStr
  Exch $R1 ; st=haystack,old$R1, $R1=needle
  Exch    ; st=old$R1,haystack
  Exch $R2 ; st=old$R1,old$R2, $R2=haystack
  Push $R3
  Push $R4
  Push $R5
  StrLen $R3 $R1
  StrCpy $R4 0
  ; $R1=needle
  ; $R2=haystack
  ; $R3=len(needle)
  ; $R4=cnt
  ; $R5=tmp
  loop:
    StrCpy $R5 $R2 $R3 $R4
    StrCmp $R5 $R1 done
    StrCmp $R5 "" done
    IntOp $R4 $R4 + 1
    Goto loop
  done:
  StrCpy $R1 $R2 $R4
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Exch $R1
FunctionEnd
;-----------------------------------------------------------------------
; StrStr
; input, top of stack = string to search for
;        top of stack-1 = string to search in
; output, top of stack (replaces with the portion of the string remaining)
; modifies no other variables.
;
; Usage:
;   Push "this is a long ass string"
;   Push "ass"
;   Call StrStr
;   Pop $R0
;  ($R0 at this point is "this is a long ")
;-----------------------------------------------------------------------
Function un.StrStr
  Exch $R1 ; st=haystack,old$R1, $R1=needle
  Exch    ; st=old$R1,haystack
  Exch $R2 ; st=old$R1,old$R2, $R2=haystack
  Push $R3
  Push $R4
  Push $R5
  StrLen $R3 $R1
  StrCpy $R4 0
  ; $R1=needle
  ; $R2=haystack
  ; $R3=len(needle)
  ; $R4=cnt
  ; $R5=tmp
  loop:
    StrCpy $R5 $R2 $R3 $R4
    StrCmp $R5 $R1 done
    StrCmp $R5 "" done
    IntOp $R4 $R4 + 1
    Goto loop
  done:
  StrCpy $R1 $R2 $R4
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Exch $R1
FunctionEnd
;-----------------------------------------------------------------------
; Replace the "replacement string" to the "string to replace"
;-----------------------------------------------------------------------
Function un.StrRep
  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
FunctionEnd
;-----------------------------------------------------------------------
; Replace the "replacement string" to the "string to replace"
;-----------------------------------------------------------------------
Function StrRep
  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
FunctionEnd
;---------------------------------------------------------------------------------------
; Delete filter 'EnhydraFilter' and delete virtual directory 'EnhydraDirector'
; during Director uninstallation
;---------------------------------------------------------------------------------------
Function un.RemovelIIS

  Banner::show /NOUNLOAD /set 76 "Delete EnhydraFilter and virtual" "directory EnhydraDirector ..."
  ; $5 = keep if IIS is selected for uninstalation

  StrCpy $R0 0 ; file handler
  ClearErrors
  
 ; If the 'EnhydraFilter' filter has already been installed, remove it.
	FileOpen $R0 $INSTDIR\IIS\uninstall\tmp.bat w
	FileWrite $R0 'cscript.exe "$INSTDIR\IIS\uninstall\removeISAPIFilter.vbs" > "$INSTDIR\IIS\uninstall\out0.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$INSTDIR\IIS\uninstall\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" "" error
  Sleep 2000   

; If a virtual directory called 'EnhydraDirector' has already existed, remove it.
	FileOpen $R0 $INSTDIR\IIS\uninstall\tmp.bat w
	FileWrite $R0 'cscript.exe "$INSTDIR\IIS\uninstall\deleteVirtualDirectory.vbs" > "$INSTDIR\IIS\uninstall\out1.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$INSTDIR\IIS\uninstall\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" end error
  Sleep 2000   
	
  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
  Abort
  
	end:
	Call un.CheckStartedIIS
	Banner::destroy

FunctionEnd
;---------------------------------------------------------------------------------------
; Delete filter 'EnhydraFilter' and delete virtual directory 'EnhydraDirector'
; during Director uninstallation
;---------------------------------------------------------------------------------------
Function UnRemovelIIS

  Banner::show /NOUNLOAD /set 76 "Delete EnhydraFilter and virtual" "directory EnhydraDirector ..."
  ; $5 = keep if IIS is selected for uninstalation

  StrCpy $R0 0 ; file handler
  ClearErrors

#  MessageBox MB_OK "Usao UnRemovelIIS - $$INSTDIR = $INSTDIR"
  
 ; If the 'EnhydraFilter' filter has already been installed, remove it.
	FileOpen $R0 $INSTDIR\IIS\uninstall\tmp.bat w
	FileWrite $R0 'cscript.exe "$INSTDIR\IIS\uninstall\removeISAPIFilter.vbs" > "$INSTDIR\IIS\uninstall\out0.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$INSTDIR\IIS\uninstall\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" "" error
  Sleep 2000   

; If a virtual directory called 'EnhydraDirector' has already existed, remove it.
	FileOpen $R0 $INSTDIR\IIS\uninstall\tmp.bat w
	FileWrite $R0 'cscript.exe "$INSTDIR\IIS\uninstall\deleteVirtualDirectory.vbs" > "$INSTDIR\IIS\uninstall\out1.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$INSTDIR\IIS\uninstall\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" end error
  Sleep 2000   
	
  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
  Abort
  
	end:
	Call CheckStartedIIS
	Banner::destroy

FunctionEnd
;------------------------------------------------------------------------------------------
; Delete filter 'EnhydraFilter' and delete virtual directory 'EnhydraDirector'
; during Director installation
;------------------------------------------------------------------------------------------
Function RemovelIIS

  StrCpy $R0 0 ; file handler
  
  StrCpy $0 0
  ClearErrors

; Check if World Wide Web Publishing Service is started
	Call CheckStartedIIS

  StrCpy $0 0
  ClearErrors
  
  ; If the 'EnhydraFilter' filter has been already installed, remove it.
	FileOpen $R0 $TEMP\EnhydraDirectorIIS\script\tmp.bat w
	FileWrite $R0 'cscript.exe "$TEMP\EnhydraDirectorIIS\script\removeISAPIFilter.vbs" > "$TEMP\EnhydraDirectorIIS\script\out0.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$TEMP\EnhydraDirectorIIS\script\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" "" error
  Sleep 2000
    
; If a virtual directory called 'EnhydraDirector' has already existed, remove it.
	FileOpen $R0 $TEMP\EnhydraDirectorIIS\script\tmp.bat w
	FileWrite $R0 'cscript.exe "$TEMP\EnhydraDirectorIIS\script\deleteVirtualDirectory.vbs" > "$TEMP\EnhydraDirectorIIS\script\out1.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$TEMP\EnhydraDirectorIIS\script\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	StrCmp $0 "0" end error
  Sleep 2000
	
  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
  Abort
  
	end:
FunctionEnd
;--------------------------------------------------------------------------------------
; Create filter 'EnhydraFilter' and create virtual directory 'EnhydraDirector'
;--------------------------------------------------------------------------------------
Function InstallIIS

  Banner::show /NOUNLOAD /set 76 "Create EnhydraFilter and virtual" "directory EnhydraDirector..."

  StrCpy $R0 0 ; file handler
  ; Add 'EnhydraFilter' filter.
	FileOpen $R0 $TEMP\EnhydraDirectorIIS\script\tmp.bat w
	FileWrite $R0 'cscript.exe "$TEMP\EnhydraDirectorIIS\script\registerISAPIFilter.vbs" "$INSTDIR\IIS\EnhydraFilter.dll" -n "EnhydraFilter" > "$TEMP\EnhydraDirectorIIS\script\out2.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$TEMP\EnhydraDirectorIIS\script\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	Sleep 3000
	StrCmp $0 "0" "" error

; Create virtual directory called 'EnhydraDirector'.
	FileOpen $R0 $TEMP\EnhydraDirectorIIS\script\tmp.bat w
	FileWrite $R0 'cscript.exe "$TEMP\EnhydraDirectorIIS\script\createVirtualDirectory.vbs" "EnhydraDirector","$INSTDIR\IIS" > "$TEMP\EnhydraDirectorIIS\script\out3.tmp"$\r$\n'
	FileClose $R0
	nsExec::ExecToLog '$TEMP\EnhydraDirectorIIS\script\tmp.bat'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
	Sleep 3000
	StrCmp $0 "0" end error
	
  error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
  Abort
  
  end:
	Banner::destroy
FunctionEnd
;------------------------------------------------------------------------------
; Check if IIS Service is started during the uninstallation
;------------------------------------------------------------------------------
Function un.CheckStartedIIS

  ClearErrors
  services::IsServiceInstalled 'W3SVC'
  Pop $0
  Pop $1
	StrCmp $0 "Yes" checkRunning end
	
	checkRunning:
  services::IsServiceRunning 'W3SVC'
  Pop $0
  Pop $1
	StrCmp $0 "Yes" stopService end

	stopService:
  services::SendServiceCommand 'stop' 'W3SVC'
  Pop $0
  Pop $1
	Sleep 3000
	StrCmp $0 "Ok" end error
	
	error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
	Abort
	
	end:
FunctionEnd
;---------------------------------------------------------------------------
; Check if IIS Service is started during the installation
;---------------------------------------------------------------------------
Function CheckStartedIIS

  ClearErrors
  services::IsServiceInstalled 'W3SVC'
  Pop $0
  Pop $1
	StrCmp $0 "Yes" checkRunning end
	
	checkRunning:
  services::IsServiceRunning 'W3SVC'
  Pop $0
  Pop $1
	StrCmp $0 "Yes" stopService end

	stopService:
  services::SendServiceCommand 'stop' 'W3SVC'
  Pop $0
  Pop $1
	Sleep 3000
	StrCmp $0 "Ok" end error
	
	error:
  MessageBox MB_OK|MB_ICONINFORMATION 'Error = $0 - $1'
	Abort
	
	end:
FunctionEnd
;------------------------------------------------------------------------------------------
; Check version of IIS
; IIS version needes : Microsoft Internet Information Server, version 4.0 or later.
;------------------------------------------------------------------------------------------
Function CheckVersionIIS

	StrCpy $8 0 ; indicator for exist IIS version 4.0 or later (0-not exist,1-exist)
	
  ReadRegDWORD $R0 HKLM "SOFTWARE\Microsoft\InetStp" MajorVersion
  ReadRegDWORD $R1 HKLM "SOFTWARE\Microsoft\InetStp" MinorVersion
  
  IntCmp $R0 4 ok versionWrong ok
  
  versionWrong:
	  SectionSetFlags ${SecIIS} ${SF_RO}
	
	ok:
	StrCpy $8 1 ; set indicator to exist IIS version 4.0 or later, requirements for IIS version OK
FunctionEnd
;-----------------------------------------------------------------------------
; POST function on components page
; check if anything is selected for an installation
;-----------------------------------------------------------------------------
Function compLeave

	;check if IIS is selected
  SectionGetFlags ${SecIIS} $0
  IntOp $0 $0 & ${SF_SELECTED}
  StrCmp $0 ${SF_SELECTED} ok 

	;check if Apache is selected
  SectionGetFlags ${SecApache} $0
  IntOp $0 $0 & ${SF_SELECTED}
  StrCmp $0 ${SF_SELECTED} ok 

  # the user didn't select the required section,
  # don't let him leave the page
  MessageBox MB_OK|MB_ICONINFORMATION 'You must check the component which do you want to install.'
  Abort

  ok:
FunctionEnd
;---------------------------------------------------------------------------------
; PRE function for directory page. If installation directory exists,
; jump this page, otherwise show it
;---------------------------------------------------------------------------------
Function dirPre

  ; read from the registry if EnhydraDirector has already been installed
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir"
  StrCmp $R0 "" ok

  StrCpy $INSTDIR $R0
  Abort

  ok:
  ; Check if Enhydra Server installed
  Call CheckEnhydraInstall  
FunctionEnd
;---------------------------------------------------------------------------------
; Check if components are selected on uninstall custom page
;---------------------------------------------------------------------------------
 Function un.CheckUninstallSelection

  StrCpy $6 0 ; keep if Apache is selected for uninstalation
  StrCpy $5 0 ; keep if IIS is selected for uninstalation

		; check if selected Apache for uninstall
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $6 \
               "uninstall.ini" \
               "Field 2" \
               "state" 

		; check if selected IIS for uninstall
    !insertmacro MUI_INSTALLOPTIONS_READ \
               $5 \
               "uninstall.ini" \
               "Field 3" \
               "state" 
	
	StrCmp $6 "0" "" start
	StrCmp $5 "0" "" start
 
  MessageBox MB_OK|MB_ICONINFORMATION 'You must check components which do you want to uninstall.'

  start:
	
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Server installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraInstall
  
  ReadRegStr $R0 HKLM "SOFTWARE\Enhydra" "Install_Dir" 
  StrCmp $R0 "" end
  ; set installation directory to <ENHYDRA_ROOT>\Director
  StrCpy $INSTDIR $R0\Director
  
  end:
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Director installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraDirector
  
	StrCpy $5 "0"
	StrCpy $6 "0"

  ; read from the registry if EnhydraDirector has already been installed
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir"
  StrCmp $R0 "" end

  MessageBox MB_YESNO "Detecting previously installation of Enhydra Director on machine. Would you like uninstall it ?" \
             IDYES uninst IDNO end
             
  uninst:
  ; read from the registry which commponents are installed 
  ; $6 = keep if Apache check for uninstalation
  ; $5 = keep if IIS check for uninstalation
  ReadRegStr $R0 HKLM "SOFTWARE\${MUI_PRODUCT}" "IIS"
	StrCmp $R0 "" checkApache 
	StrCpy $5 "1"
	
	checkApache:
  ReadRegStr $R1 HKLM "SOFTWARE\${MUI_PRODUCT}" "Apache"
	StrCmp $R1 "" start
	StrCpy $6 "1"

  start:
	StrCmp $5 "1" "" continue
#  MessageBox MB_OK "Uninstall IIS - $$6=$6"
  ReadRegStr $INSTDIR HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir"
	Call UninstallIIS
#  MessageBox MB_OK "PROSAO-Uninstall IIS - $$6=$6"

  continue:
	StrCmp $6 "1" "" end
#  MessageBox MB_OK "Uninstall Apache"
  ReadRegStr $INSTDIR HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir"
  Call ApacheAllInstaled
	Call UninstallApache	
  
  end:
FunctionEnd

;---------------------------------------------------------------------------------
; Uninstall Apache from install
;---------------------------------------------------------------------------------
Function ApacheAllInstaled


  StrCpy $8 ""  ; Apache Server root path for selected apache version
  StrCpy $7 ""  ; Apache version string for selected apache version
  StrCpy $R0 0  ; count number of field elements
  StrCpy $R1 0  ; temp
  StrCpy $R2 0  ; temp
  ; read from the registry which apache version is installed
  loop0:
    EnumRegKey $R1 HKLM "SOFTWARE\${MUI_PRODUCT}\Apache" $R0
    StrCmp $R1 "" end
    StrCpy $7 "$7$R1,"
    ReadRegStr $R2 HKLM "SOFTWARE\${MUI_PRODUCT}\Apache\$R1" "ServerRoot"      
    StrCpy $8 "$8$R2,"
    IntOp $R0 $R0 + 1
  goto loop0

   end:
FunctionEnd

